/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cenemy class


*******************************************************************************
******************************************************************************/



#include <nds.h>

#include "cearn_atan.h"
#include "Cspline.h"
#include "Cobject.h"
#include "Cenemy.h"

/******************************************************************************

.12 FP
******************************************************************************/
void ai_spline(Cenemy *en)
{

	//int _x = en->x;
	//int _y = en->y;
	
	en->points.update();
	
	en->x = en->points.x;
	en->y = en->points.y;

	//en->dx = en->x - _x;
	//en->dy = en->y - _y;

}


/******************************************************************************

	en.dy = center line
	.12 FP	
******************************************************************************/
void ai_sine_v(Cenemy *en)
{
	
	en->angle += en->angle_speed;
	int dy = (sinLerp(en->angle)) * (en->radius);
	en->x += en->dx;
	en->y  = en->dy + dy;
	
}

/******************************************************************************


******************************************************************************/
void init_points_rotator_u(Cenemy *en, int _x, int _y, int _t)
{
	en->points.init_coords(7);
	en->points.tval = _t;
	en->points.speed = 16 ;
	
	Tcoord p;
	
	p.x = _x;
	p.y = _y;
	en->points.p_coords[0] = p;
	en->points.p_coords[1] = p;
	
	p.x = _x - 50;
	p.y = _y - 60;
	en->points.p_coords[2] = p;
	
	p.x = _x - 100;
	p.y = _y + 60;
	en->points.p_coords[3] = p;

	p.x = _x -200;
	p.y = _y ;
	en->points.p_coords[4] = p;

	p.x = _x -380;
	p.y = _y ;
	en->points.p_coords[5] = p;

	p.x = _x -380;;
	p.y = _y ;
	en->points.p_coords[6] = p;

}


/******************************************************************************


******************************************************************************/
void init_points_rotator_d(Cenemy *en, int _x, int _y, int _t)
{
	en->points.init_coords(7);
	en->points.tval = _t;
	en->points.speed = 16 ;
	
	Tcoord p;
	
	p.x = _x;
	p.y = _y;
	en->points.p_coords[0] = p;
	en->points.p_coords[1] = p;
	
	p.x = _x - 50;
	p.y = _y + 60;
	en->points.p_coords[2] = p;
	
	p.x = _x - 100;
	p.y = _y - 60;
	en->points.p_coords[3] = p;

	p.x = _x -200;
	p.y = _y ;
	en->points.p_coords[4] = p;

	p.x = _x -380;
	p.y = _y ;
	en->points.p_coords[5] = p;

	p.x = _x -380;;
	p.y = _y ;
	en->points.p_coords[6] = p;

}

/******************************************************************************


******************************************************************************/
void Cenemy::animate()
{

	// animate 
	if ( anim_counter >= anim_delay)
	{
		frame++;
		if ( frame >= num_frames)
			frame = 0;
		
		anim_counter = -1;
	}

	// inc counter
	anim_counter++;
}

/******************************************************************************


******************************************************************************/
void Cenemy::init_spline(u32 maxpoints, int _sx, int _sy, int _ex, int _ey)
{
	
	points.init_coords(maxpoints);
	
	
	// randomize for now
	for (int i=2; i<points.max_index-2; i++)
	{
		points.p_coords[i].x = qran_range(0, 256);
		points.p_coords[i].y = qran_range(9, 192);
	}
	
	// close first 2 coords
	points.p_coords[0].x = _sx;
	points.p_coords[0].y = _sy;

	points.p_coords[1].x = _sx;
	points.p_coords[1].y = _sy;

	// close last 2 
	points.p_coords[points.max_index-2].x = _ex;
	points.p_coords[points.max_index-2].y = _ey;

	points.p_coords[points.max_index-1].x = _ex;
	points.p_coords[points.max_index-1].y = _ey;

	points.speed = qran_range(16,48);
	points.tval = 0;
	
}

/******************************************************************************


******************************************************************************/
void Cenemy::update()
{

	animate();

	do_ai(this);
		
	resolve_aabb_f32();
	
	if (hit_cooldown > 0)
		hit_cooldown--;
	
}

void Cenemy::reset()
{
	angle = 0;
	counter = 0;
	deathID = EX_NONE;
	alive = false;
}

/******************************************************************************



	Initializes an enemy in real-time
	Parameters:
	_ID 		= enum for enemy id
	_x  		= starting x coord
	_y  		= starting y coord
	_dx			= the x velocity
	_dy			= the y velocity
	_splineT 	= Start time value for splines (0 - 4095)
				(also used for start angles(0 to 32767) in sine and circle based movements)
	_anglespeed = speed of rotation for sine-based enemies(0 to 32767)
	_radius		= radius for sine and circle movements
	sprites		= Csprite array to get bounding boxes from
	
******************************************************************************/

void Cenemy::start(EN_ENEMY_ID _ID, int _x, int _y, int _dx, int _dy,
				   int _splineT, int _anglespeed, int _radius, const Cglsprite *sprites)
{
	int _numframes;
	
	ID = _ID;
	active = true;
	 
	switch (ID)
	{

		case EN_AMOEBA:
			start_frame = 10;
			_numframes = 6;
			hp = 10;
			deathID = EX_SMALL_2;
			init_spline(SPLINE_MAX_POINTS, 300, qran_range(0, 180), -100, qran_range(0, 180));
			do_ai = ai_spline;
			break;
			
		case EN_ROTATOR_U:
			start_frame = 0;
			_numframes = 4;
			hp = 7;
			deathID = EX_MEDIUM_1;
			init_points_rotator_u(this, _x, _y, _splineT);
			do_ai = ai_spline;
			break;
			
		case EN_ROTATOR_D:
			start_frame = 0;
			_numframes = 4;
			hp = 7;
			deathID = EX_MEDIUM_1;
			init_points_rotator_d(this, _x, _y, _splineT);
			do_ai = ai_spline;
			break;
			
		case EN_WAVER_U:
			start_frame = 22;
			_numframes = 8;
			hp = 8;
			deathID = EX_MEDIUM_2;
			x = _x << 12;
			y = _y << 12;
			dx = _dx << 12;
			dy = _y << 12;
			angle = _splineT;
			radius = _radius;
			angle_speed = _anglespeed;
			do_ai = ai_sine_v;
			break;
		
		case EN_WAVER_D:
			start_frame = 22;
			_numframes = 8;
			hp = 8;
			deathID = EX_MEDIUM_2;
			x = _x << 12;
			y = _y << 12;
			dx = _dx << 12;
			dy = _y << 12;
			angle = _splineT;
			radius = _radius;
			angle_speed = _anglespeed;
			do_ai = ai_sine_v;
			break;
			
		default:
			start_frame = 10;
			_numframes = 6;
			hp = 10;
			deathID = EX_SMALL_1;
			init_spline(SPLINE_MAX_POINTS, 300, qran_range(0, 180), -100, qran_range(0, 180));
			do_ai = ai_spline;

	}   // end switch

	// set up Cobject parameters
	init(sprites[start_frame].width, sprites[start_frame].height, _numframes);

}



/******************************************************************************


******************************************************************************/


void Cenemies::update()
{

	for (int i=0; i<MAX_ENEMIES; i++)
	{
		if (enemy[i].active)
		{
			enemy[i].update();
			if ( (enemy[i].x >> 12) < -20 )
				kill(i);
		}
	}
	
}


void Cenemies::draw(Cglsprite *sprites)
{
	for (int i=0; i<MAX_ENEMIES; i++)
	{
		if (enemy[i].active)
		{
			int frame = enemy[i].start_frame + enemy[i].frame;
			
			if (enemy[i].draw_mode != E_COLOR)
			{
				sprites[frame].render(enemy[i].x >> 12, enemy[i].y >> 12);
			}
			else
			{
				switch (enemy[i].hit_cooldown)
				{
					case 0:
						sprites[frame].color(enemy[i].x >> 12, enemy[i].y >> 12, RGB15(31,0,0));
						break;
					case 1:
						sprites[frame].color(enemy[i].x >> 12, enemy[i].y >> 12, RGB15(0,31,31));
						break;
					case 2:
						sprites[frame].color(enemy[i].x >> 12, enemy[i].y >> 12, RGB15(31,0,31));
						break;
					default:
						sprites[frame].color(enemy[i].x >> 12, enemy[i].y >> 12, RGB15(0,0,31));
				}
				
				if (enemy[i].hit_cooldown == 0) enemy[i].draw_mode = E_NORMAL;
			}	// drawmode
		}	// active
		
	}	//next i

}

void Cenemies::draw_aabb(Cgl2d &gl2d)
{

	for (int i=0; i<MAX_ENEMIES; i++)
	{
		if (enemy[i].active)
		{
			int x1 = enemy[i].box.x1;
			int y1 = enemy[i].box.y1;
			int x2 = enemy[i].box.x2;
			int y2 = enemy[i].box.y2;
			gl2d.box(x1, y1, x2, y2, ARGB16(1,31,31,31));
		}
	}
	
}

/******************************************************************************

	Initializes an enemy in real-time
	Parameters:
	_ID 		= enum for enemy id
	_x  		= starting x coord
	_y  		= starting y coord
	_dx			= the x velocity
	_dy			= the y velocity
	_splineT 	= Start time value for splines (0 - 4095)
				(also used for start angles(0 to 32767) in sine and circle based movements)
	_anglespeed = speed of rotation for sine-based enemies(0 to 32767)
	_radius		= radius for sine and circle movements
	sprites		= Csprite array to get bounding boxes from
	
******************************************************************************/

void Cenemies::add(EN_ENEMY_ID _ID, int _x, int _y, int _dx, int _dy,
				   int _splineT, int _anglespeed, int _radius, const Cglsprite *sprites)
{

	// find a free slot and add the enemy
	for (int i=0; i<MAX_ENEMIES; i++)
	{
		if (!enemy[i].active)
		{
			enemy[i].start( _ID, _x, _y, _dx, _dy, 
							_splineT, _anglespeed, _radius, sprites);
			num_enemies++;
			break;
		}
	}
}


/******************************************************************************


******************************************************************************/

void Cenemies::kill(int _index)
{
	enemy[_index].active = false;
	enemy[_index].alive = false;
	num_enemies--;
}





/******************************************************************************


******************************************************************************/

void Cenemies::add_wave_amoeba(int _num_enemies, const Cglsprite *sprites)
{

	for (int i= 0; i< _num_enemies; i++)
		add(EN_AMOEBA, 300, 90, 0, 0,
			LIMIT_SPLINE_TIMER(i * 512), 0, 0, sprites);

}


/******************************************************************************


******************************************************************************/

void Cenemies::add_wave_rotator_u(int _num_enemies, const Cglsprite *sprites)
{

	for (int i= 0; i< _num_enemies; i++)
		add(EN_ROTATOR_U, 300, 90, 0, 0,
			LIMIT_SPLINE_TIMER(i * 512), 0, 0, sprites);
			
}

/******************************************************************************


******************************************************************************/

void Cenemies::add_wave_rotator_d(int _num_enemies, const Cglsprite *sprites)
{

	for (int i= 0; i< _num_enemies; i++)
		add(EN_ROTATOR_D, 300, 90, 0, 0,
			LIMIT_SPLINE_TIMER(i * 512), 0, 0, sprites);
			
}


/******************************************************************************


******************************************************************************/

void Cenemies::add_wave_wavers_u(int _num_enemies, int _y, const Cglsprite *sprites)
{
	for (int i= 0; i< _num_enemies; i++)
		add(EN_WAVER_U, 256 + (i * 20), _y, -1, 0,
			32767-(i << 11), 128, 50, sprites);
			
}

/******************************************************************************


******************************************************************************/

void Cenemies::add_wave_wavers_d(int _num_enemies, int _y, const Cglsprite *sprites)
{
	for (int i= 0; i< _num_enemies; i++)
		add(EN_WAVER_D, 256 + (i * 20), _y, -1, 0,
			(i << 11), -128, 50, sprites);
			
}
