/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cenemy class


*******************************************************************************
******************************************************************************/



#include <nds.h>

#include "cearn_atan.h"
#include "Cglsprite.h"
#include "Cgl2d.h"
#include "Cspline.h"
#include "Cobject.h"
#include "Cexplosion.h"

#ifndef Cenemy__H
#define Cenemy__H

#define  MAX_ENEMIES 64

enum EN_ENEMY_ID
{

	EN_NONE = 0,
		EN_AMOEBA,
		EN_ROTATOR_U,
		EN_ROTATOR_D,
		EN_WAVER_U,
		EN_WAVER_D,
		EN_SLUG_F_RADIAL,
		EN_SPERM,
		EN_SWINGER,
	EN_END_NORMAL,
	
	// Smart enemies
	EN_SMART,	
		EN_AMOEBA_SMART,	
		EN_BALLOON_SMART,		
	EN_END_SMART,
	
	//retargeting (means that they always home in on the player)
	EN_RETARGET,	
		EN_AMOEBA_SMART_RETARGET,		
	EN_END_RETARGET,
	
	
	// special animated enemies like cannons
	// and spawners
	EN_SPECIAL,	
		EN_ORGANIC_CANNON_U,
		EN_ORGANIC_CANNON_D,
		EN_ORGANIC_BATTERY_U,
		EN_ORGANIC_BATTERY_D,
		EN_SPAWN_U_ROTATORS,
		EN_SPAWN_D_ROTATORS,
		EN_SPAWN_U_WAVER,
		EN_SPAWN_D_WAVER,
		EN_WAVER_BATTERY_U,
		EN_WAVER_BATTERY_D,
		EN_BALLOON,
		EN_TENTACLAW_U,
		EN_TENTACLAW_D,
	EN_END_SPECIAL
	
};

// Cenemy class derived from Cobject
class Cenemy : public Cobject
{
	public:
	
	void animate();
	void init_spline(u32 maxpoints, int _sx, int _sy, int _ex, int _ey);
	void update();
	void reset();
	void start(EN_ENEMY_ID _ID, int _x, int _y, int _dx, int _dy,
			   int _splineT, int _anglespeed, int _radius, const Cglsprite *sprites);
	void (*do_ai)(Cenemy *en);
	
	EN_ENEMY_ID ID;
	int 		angle;
	int 		radius;
	int 		angle_speed;
	int 		counter;
	E_EXPLOSION	deathID;
	bool 		alive;
	int 		hp;
	
	
	int hit_cooldown;		// var just to make the hit color last longer
	Cspline points;
	
};

// enemy class api
class Cenemies
{
	public:
	void update();
	void draw(Cglsprite *sprites);
	void draw_aabb(Cgl2d &gl2d);
	void add(EN_ENEMY_ID _ID, int _x, int _y, int _dx, int _dy,
			 int _splineT, int _anglespeed, int _radius, const Cglsprite *sprites);
	void kill(int _index);
	
	int num_enemies;
	
	//private:
	
	Cenemy enemy[MAX_ENEMIES];
	
	// special funks
	void add_wave_amoeba(int _num_enemies, const Cglsprite *sprites);
	void add_wave_rotator_u(int _num_enemies, const Cglsprite *sprites);
	void add_wave_rotator_d(int _num_enemies, const Cglsprite *sprites);
	void add_wave_wavers_u(int _num_enemies, int _y, const Cglsprite *sprites);
	void add_wave_wavers_d(int _num_enemies, int _y, const Cglsprite *sprites);
	
};

#endif

