/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cexplosion class


*******************************************************************************
******************************************************************************/



#include <nds.h>

#include "Cobject.h"
#include "Cexplosion.h"


/******************************************************************************

	Cexplode

******************************************************************************/

Cexplode::Cexplode()
{

	x                	= 0;
	y                	= 0;
	dx               	= 0;
	dy               	= 0;
	active		    	= false;
	anim_counter		= 0;
	ex_type   		    = EX_TINY_1;
	start_frame      	= 140;
	frame            	= 0;
	num_frames        	= 5;
	anim_delay    		= 3;  // should be pow of 2-1
}

/******************************************************************************


******************************************************************************/
Cexplode::~Cexplode()
{
}


/******************************************************************************


******************************************************************************/
void Cexplode::update()
{
	
   x += dx;
   y += dy;


   anim_counter = (anim_counter + 1) & anim_delay;

   if (anim_counter == 0)
	  frame++;
   
   if ( frame>= num_frames )
	  deactivate();
   
}

/********************************************************

	Expects:
	tx, ty, vx, and vy to be .12 FP

********************************************************/
void Cexplode::activate(E_EXPLOSION _ex_type, int tx, int ty, int vx, int vy)
{


	active		    	= true;
	ex_type   		    = _ex_type;

	x                	= tx;
	y                	= ty;
	dx               	= vx;
	dy               	= vy;


	frame            	= 0;
	anim_counter		= 0;
	anim_delay    		= 3;  // should be pow of 2 - 1

	switch (_ex_type)
	{
		case EX_TINY_1:
			cx_off				= 4 << 12;
			cy_off				= 4 << 12;
			start_frame      	= 140;
			num_frames        	= 5;
			break;
		case EX_TINY_2:
			cx_off				= 4 << 12;
			cy_off				= 4 << 12;
			start_frame      	= 131;
			num_frames        	= 5;
			break;
		case EX_SMALL_1:
			cx_off				= 4 << 12;
			cy_off				= 4 << 12;
			start_frame      	= 118;
			num_frames        	= 8;
			break;
		case EX_SMALL_2:
			cx_off				= 8 << 12;
			cy_off				= 8 << 12;
			start_frame      	= 136;
			num_frames        	= 4;
			break;
		case EX_MEDIUM_1:
			cx_off				= 8 << 12;
			cy_off				= 8 << 12;
			start_frame      	= 108;
			num_frames        	= 4;
			break;
		case EX_MEDIUM_2:
			cx_off				= 8 << 12;
			cy_off				= 8 << 12;
			start_frame      	= 112;
			num_frames        	= 6;
			break;
		case EX_BIG:
			cx_off				= 8 << 12;
			cy_off				= 8 << 12;
			start_frame      	= 126;
			num_frames        	= 5;
			break;
		default:
			cx_off				= 4 << 12;
			cy_off				= 4 << 12;
			start_frame      	= 140;
			num_frames        	= 5;
			
	}
	
}

/******************************************************************************


******************************************************************************/
void Cexplode::deactivate()
{

	active		   		= false;
	anim_counter		= 0;
	ex_type   		   	= EX_NONE;
    
}



/******************************************************************************

	Cexplosion

******************************************************************************/

void Cexplosion::update()
{

	for (int i=0; i<MAX_EXPLOSIONS; i++)
	{
		if (a_explosions[i].active)
			a_explosions[i].update();
	}

}
	
/********************************************************

	Expects:
	tx, ty, vx, and vy to be .12 FP

********************************************************/
void Cexplosion::add(E_EXPLOSION _ex_type, int tx, int ty, int vx, int vy)
{
	for (int i=0; i<MAX_EXPLOSIONS; i++)
	{	
		if (!a_explosions[i].active)
		{
			a_explosions[i].activate(_ex_type, tx, ty, vx, vy);
			break;
		}
	}
}


/******************************************************************************


******************************************************************************/
void Cexplosion::draw(Cglsprite *sprites)
{
	int sx, sy, f;
	
	for (int i=0; i<MAX_EXPLOSIONS; i++)
	{
		
		if (a_explosions[i].active)
		{
			sx = a_explosions[i].x - a_explosions[i].cx_off;
			sy = a_explosions[i].y - a_explosions[i].cy_off;
			f = a_explosions[i].start_frame + a_explosions[i].frame;
			sprites[f].render(sx >> 12,sy >> 12);
		}
		
	}
}
