/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cviper class


*******************************************************************************
******************************************************************************/



#include <nds.h>

#include "Cobject.h"
#include "Cshot.h"
#include "Coption.h"
#include "Cenemy.h"
#include "Cviper.h"


/******************************************************************************


******************************************************************************/
Cviper::Cviper()
{
	x = 10;
	y = 96-16;
	frame = 2;
	shot_delay = MAX_VIPER_SHOT_DELAY;
	option_shot_delay = MAX_OPTION_SHOT_DELAY;
	
	jet_counter = 0;
	jet_frame = 0;
	
}


/******************************************************************************


******************************************************************************/
void Cviper::start_shots(s32 start_x, s32 start_y)
{
	
	for(int i=0; i<MAX_VIPER_BULLETS; i++)
	{
		if (!shots[i].active)
		{
			shots[i].active = true;
			shots[i].x = start_x;
			shots[i].y = start_y;
			shots[i].dx = VIPER_SHOT_SPEED;
			shots[i].dy = 0;
			shots[i].shot_ID = E_SHOT_NORMAL;
			shots[i].frame = (i & 1);
			shots[i].start_frame = 40;
			break;
		}
	}
	
}


/******************************************************************************


******************************************************************************/
void Cviper::start_wave_shots(s32 start_x, s32 start_y)
{

	static s16 sine_off = 0;
	s16 angle;
	
	
	sine_off += 1024;
	for (int j=0; j<2; j++)
	{	
		if (j==0)
			angle = FP_PI+sine_off;
		else
			angle = sine_off;
		        
				
		for (int i=0; i<MAX_VIPER_BULLETS; i++)
		{
			if (!shots[i].active)
			{
				shots[i].active = true;
				shots[i].x = start_x;
				shots[i].y = start_y;
				shots[i].dx = VIPER_SHOT_SPEED-2;
				shots[i].dy = start_y;
				shots[i].angle = angle;
				shots[i].radius = 0;
				shots[i].shot_ID = E_SHOT_WAVE;
				shots[i].frame = 0;
				shots[i].start_frame = 42;
				break;
			}
		}
	}

}

/******************************************************************************


******************************************************************************/
void Cviper::do_shots()
{
	for(int i=0; i<MAX_VIPER_BULLETS; i++)
	{
		if (shots[i].active)
		{
			if (shots[i].shot_ID == E_SHOT_NORMAL)
			{
				shots[i].x += shots[i].dx;
				shots[i].y += shots[i].dy;
			}
			else
			{
				shots[i].angle += 800;
				shots[i].radius += 3000;
				s32 dy = (sinLerp(shots[i].angle)) * (shots[i].radius);
				
				shots[i].x += shots[i].dx;
				shots[i].y = shots[i].dy + (dy >> 24);         
			}
			
			
			if (shots[i].x > SCREEN_WIDTH)
			{
				shots[i].active = false;
			}
			
			shots[i].resolve_aabb();
			
		}
	}
}

/******************************************************************************


******************************************************************************/
void Cviper::control(Cenemy &target)
{

	dx = 0;
	dy = 0;
	
	
	direction = E_NEUTRAL;
	if ( !(state & E_LOCKED) )
	{
		if (key_held & KEY_LEFT)
		{
			direction = E_LEFT;
			if (x > 0) 
				dx -= 3;
		}
		
		if (key_held & KEY_RIGHT) 	
		{
			direction = E_RIGHT;
			if (x < SCREEN_WIDTH-width) 
				dx += 3;
		}
		
		if (key_held & KEY_UP)
		{
			direction = E_UP;
			if (y > 0) 
				dy -= 2;
		}
		
		if (key_held & KEY_DOWN) 	
		{
			direction = E_DOWN;
			if (y < SCREEN_HEIGHT-height) 
				dy += 2;
		}
		
		if (key_held & KEY_A)
		{

			shot_delay--;
			if(shot_delay == 0)
			{
				
				shot_delay = MAX_VIPER_SHOT_DELAY;
				start_shots(x+24,y+4);
				start_wave_shots(x+24,y+4);
					
			}
			
			option_shot_delay--;
			if(option_shot_delay == 0)
			{
				
				option_shot_delay = MAX_OPTION_SHOT_DELAY;
				for (int i=0; i < MAX_OPTIONS; i++)
				{
					options[i].start_shots(options[i].x+4, options[i].y+4, target.x+16, target.y+8);
				}
				
					
			}
			
		}
	}
	else	// auto control
	{
		direction = E_RIGHT;
		if (x < 60) 
		{
			dx += 3;
		}
		else
		{
			state &= ~E_LOCKED;
			state &= ~E_INVINCIBLE;
		}
	}
	

}

/******************************************************************************


******************************************************************************/
void Cviper::update()
{

	static s8 _direction_counter = 0;
	static s8 _direction = 0;
	
	x += dx;
	y += dy;
	
	resolve_aabb();
	
	//shrink AABBint 
	//box.shrink(12,6);
	box.shrink(2400);
	

 	// check direction
	if (dy < 0)
		_direction = -1;
	else if (dy > 0)
		_direction = 1;
	else
		_direction = 0;
	
	
	// set up dir counter whenever we move up or down
	if (_direction < 0 || direction == E_UP)						// up
	{
		if (_direction_counter < 32) 
			_direction_counter++;
	}
	else if (_direction > 0 || direction == E_DOWN)					// down
	{
		if (_direction_counter > -32) 
			_direction_counter--;
	}
	else		// cool down when not moving up or down
	{
		if (direction == E_NEUTRAL || direction == E_RIGHT || direction == E_LEFT)
		{
			if (_direction_counter > 0) 
				_direction_counter--;
			else if (_direction_counter < 0)
				_direction_counter++;
		}
	}
	
	
	frame = 2+(_direction_counter >> 4);
	
	
	// move shots and update shots to oam
	do_shots();
	
	// do options and update options to oam
	for (int i=0; i < MAX_OPTIONS; i++)
	{
		options[i].do_shots();
		options[i].update(x+8,y);
	}
	
	// jet animations
	jet_counter++;
	if ( (jet_counter & 7) == 0 ) 
	{
		jet_frame++;
		jet_frame = jet_frame & 3;
	}
	
}

/******************************************************************************


******************************************************************************/
void Cviper::initialize()
{
	
	int width = 32;
	int height = 16;
		
	
	init(width, height, 5);
	
	
	//init_bullets
	width = 16;
	height = 8;
	
	
	for(int i=0; i<MAX_VIPER_BULLETS; i++)
	{
		shots[i].init(width, height, 1);
		shots[i].active = false;
		shots[i].start_frame = 0;
	}
	
	
	for(int i=0; i<MAX_OPTIONS; i++)
	{
		options[i].initialize();
		options[i].angle = (i * FP_PI);
	}
	
}

/******************************************************************************


******************************************************************************/
void Cviper::newlife()
{
	state = E_ALIVE | E_LOCKED | E_INVINCIBLE;
	
	x = START_X;
	y = 96-16;
	
}

/******************************************************************************


******************************************************************************/
void Cviper::render(Cglsprite *sprites)
{
	static int _counter = 0;
	_counter++;
	// viper
	if (!(state & E_INVINCIBLE))
	{
		sprites[frame].render(x,y);
		// jet start of jet is frame#9
		sprites[jet_frame + 9].render(x-1,y+5);
	}
	else
	{
		if (_counter & 1)
		{
			sprites[frame].render(x,y);
			sprites[jet_frame + 9].render(x-1,y+5);
		}
	}
	



	// options
	for (int i=0; i < MAX_OPTIONS; i++)
	{
		int frame = options[i].start_frame + options[i].frame;
		sprites[frame].render(options[i].x, options[i].y);
		// jet start of jet is frame#9
		sprites[jet_frame + 9].render(options[i].x-7,options[i].y+5);
		// option shots
		for(int j=0; j<MAX_OPTION_BULLETS; j++)
		{
			if (options[i].shots[j].active)
			{
				int frame = options[i].shots[j].start_frame + options[i].shots[j].frame;
				sprites[frame].render(options[i].shots[j].x >> 12, options[i].shots[j].y >> 12);
			}
		}
	}


	// viper shots
	for(int i=0; i<MAX_VIPER_BULLETS; i++)
	{
		if (shots[i].active)
		{
			int frame = shots[i].start_frame + shots[i].frame;
			sprites[frame].render(shots[i].x, shots[i].y);
		}
	}
	
}


/******************************************************************************


******************************************************************************/

void Cviper::draw_aabb(Cgl2d &gl2d)
{

	// options
	for (int i=0; i < MAX_OPTIONS; i++)
	{
		int x1 = options[i].box.x1;
		int y1 = options[i].box.y1;
		int x2 = options[i].box.x2;
		int y2 = options[i].box.y2;
		gl2d.box(x1, y1, x2, y2, ARGB16(1,31,0,31));

		// option shots
		for(int j=0; j<MAX_OPTION_BULLETS; j++)
		{
			if (options[i].shots[j].active)
			{
				int x1 = options[i].shots[j].box.x1;
				int y1 = options[i].shots[j].box.y1;
				int x2 = options[i].shots[j].box.x2;
				int y2 = options[i].shots[j].box.y2;
				gl2d.box(x1, y1, x2, y2, ARGB16(1,0,31,31));
			}
		}
	}
	
	
	// viper shots
	for(int i=0; i<MAX_VIPER_BULLETS; i++)
	{
		if (shots[i].active)
		{
			int x1 = shots[i].box.x1;
			int y1 = shots[i].box.y1;
			int x2 = shots[i].box.x2;
			int y2 = shots[i].box.y2;
			gl2d.box(x1, y1, x2, y2, ARGB16(1,0,31,31));
		}
	}
	
	// viper
	
	
	int x1 = box.x1;
	int y1 = box.y1;
	int x2 = box.x2;
	int y2 = box.y2;
	
	
	gl2d.box(x1, y1, x2, y2, ARGB16(1,31,31,0));
				
}

